<?php
/*
Copyright (C) 2007 Stephane Graber <stgraber@ubuntu.com>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

function qatracker_event_newbuild($buildids) {
	if (!is_array($buildids) || !is_numeric($buildids[0]) || $buildids[0] < 1)
		return "";
	$or="";
	$build="";
	foreach ($buildids as $buildid) {
		if ($build == "")
			$build=$buildid;
		else
			$or.="OR qatracker_build.id='".$buildid."'";
	}
	$query=db_query("SELECT 
			DISTINCT users.uid, users.mail, qawebsite_site.id
			FROM qatracker_user_subscription
			LEFT JOIN users ON users.uid=qatracker_user_subscription.userid
			LEFT JOIN qatracker_testcase ON qatracker_testcase.id=qatracker_user_subscription.testcaseid
			LEFT JOIN qatracker_product ON qatracker_product.id=qatracker_testcase.productid
			LEFT JOIN qatracker_build ON qatracker_build.productid=qatracker_product.id
			LEFT JOIN qawebsite_site ON qawebsite_site.id=qatracker_product.siteid
			WHERE (qatracker_build.id='".$build."' $or) AND qatracker_testcase.status='0'");
	$count=0;
	while ($user = db_fetch_object($query)) {
		if (db_result(db_query("SELECT count(value) FROM qawebsite_user_setting_info LEFT JOIN qawebsite_user_setting ON qawebsite_user_setting.id=qawebsite_user_setting_info.settingid WHERE qawebsite_user_setting.title='E-Mail notification' AND qawebsite_user_setting_info.userid='".$user->uid."' AND qawebsite_user_setting_info.value='1'")) == "1") {
			$content.="";
			$query1=db_query("SELECT 
				qatracker_testcase.title as testcase, 
				qatracker_testcase.id as testcaseid,
				qatracker_build.id as buildid,
				qatracker_build.version as version,
				qawebsite_site.title as site, 
				qawebsite_site.subdomain,
				qatracker_product.title as product
				FROM qatracker_user_subscription
				LEFT JOIN users ON users.uid=qatracker_user_subscription.userid
				LEFT JOIN qatracker_testcase ON qatracker_testcase.id=qatracker_user_subscription.testcaseid
				LEFT JOIN qatracker_product ON qatracker_product.id=qatracker_testcase.productid
				LEFT JOIN qawebsite_site ON qawebsite_site.id=qatracker_product.siteid
				LEFT JOIN qatracker_build ON qatracker_build.productid=qatracker_product.id
				WHERE (qatracker_build.id='".$build."' $or) AND qatracker_user_subscription.userid='".$user->uid."' AND qatracker_testcase.status='0'");
$body="
You are receiving this email because you have been subscribed to the 
following test case:
";
			$lastproduct="";
			while ($item = db_fetch_object($query1)) {
				$version=$item->version;
				if ($item->product != $lastproduct) {
					$body.="\n".$item->product." [".$version."]: http://".$item->subdomain."/qatracker/info/".$item->buildid."\n";
					$lastproduct=$item->product;
				}
				$body.=" ".$item->testcase.": http://".$item->subdomain."/qatracker/result/".$item->buildid."/".$item->testcaseid."\n";
			}
$body.="
Please report any bugs you identify in Launchpad and report on the 
success or failure of the test in the tracker:
https://launchpad.net/ubuntu/

Please see the testing team wiki pages for for further information:
https://wiki.ubuntu.com/Testing

For questions about the procedure or to coordinate testing, please join 
#ubuntu-testing on freenode.

Thank you for helping us to test Ubuntu.
";
			mail($user->mail,"Ubuntu QA Tracker: New build notification [".$version."]",$body,"From: QA Testing Tracker <qatracker@stgraber.org>\nContent-Type: text/plain; charset=utf-8");
			$count++;
		}
	}
	return $count;
}

?>
