#!/usr/bin/python
# Copyright (C) 2010 Canonical Ltd.
# Written by Ara Pulido <ara@ubuntu.com>
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
# Database settings

db_host=
db_user=
db_password=
db_database=

import sys, pgdb
from optparse import OptionParser

usage = '%prog output_file'
parser = OptionParser(usage)

parser.add_option("-s", "--site",
                  action="store", dest="site_id", default=1,
                  help="site id of the tracker (default=1)")

(options, args) = parser.parse_args ()

if len (args) != 1:
    parser.error ('Incorrect number of arguments.')

# Connect to the DB
try:
    db=pgdb.connect(user=db_user,password=db_password,host=db_host,database=db_database)
    cursor=db.cursor()
except:
    sys.exit("Failed to connect to the DB")

# Open the output
output_file = open(args[0], "w")
header = "launchpadid,results\n"
output_file.write(header)

sqlQuery = "SELECT i.value AS launchpadid, count(r.id) AS number_results \
            FROM qatracker_result r \
            LEFT JOIN qatracker_build b ON r.buildid = b.id \
            LEFT JOIN qatracker_milestone m ON b.milestoneid = m.id \
            LEFT JOIN qawebsite_user_setting_info i ON reporterid = i.userid \
            WHERE m.status = 0 AND m.siteid = " + str(options.site_id) + " AND i.settingid = 1 \
            AND i.value != '' \
            GROUP BY launchpadid \
            ORDER BY number_results DESC"

try:
    cursor.execute(sqlQuery)
    halloffame = cursor.fetchall()
    for user in halloffame:
        output_file.write(str(user[0]) + "," + str(user[1]) + "\n")
except KeyboardInterrupt:
    sys.exit("KeyboardInterrupt caught.") 
except:
    raise

#Close DB connection
cursor.close()
db.close()
output_file.close()
